#!/usr/bin/perl -w
BEGIN { unshift @INC, "../../scripts/lib"; }
use Tools;

my $pidFile = "../../../usr/local/sphinx/log/searchd.pid";

debug("Sphinx daemon treminating...");
debug("");


do {
	-f $pidFile or error("Daemon is not running.");
	open(local *F, $pidFile) or error("Cannot open the PID file $pidFile: $!\n");
	my $pid = trim(<F>);
	$pid or error("PID file $pidFile is empty!");
	kill(9, $pid);
	sleep 1; # this sleep is for unlink the lock file
	debug("Terminated process $pid.");
};
my $err = @_;
die $err if $err;
exit(0);


sub debug {
	print STDERR "[" . scalar(localtime) . "] " . join("", @_) . "\n";
}


sub error {
	print STDERR "[" . scalar(localtime) . "] " . join("", @_) . "\n";
	exit(1);	
}