<?php
if (isset($_GET['get_file'])) {
	$filename = str_replace(array('\\', '/'), array('',''), $_GET['get_file']);
	if (!file_exists(PROJECT_ROOT.'var/cache/'.$filename) || is_dir(PROJECT_ROOT.'var/cache/'.$filename)) {
		NFW::i()->stop('File not found');
		return false;
	}

	header('Content-type: application/force-download');
	header('Content-Disposition: attachment; filename="test-demo.zip"');
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: ".filesize(PROJECT_ROOT.'var/cache/'.$filename));
	readfile(PROJECT_ROOT.'var/cache/'.$filename);
	exit;
}
elseif (empty($_POST)) {
	// Main page
	NFW::i()->setUI('bootstrap');
	
	$CPages = new pages();
	$CPages->record['content'] = $CPages->renderAction(array(), 'demo_maker');
	$CPages->record['title'] = NFW::i()->cfg['project_name'].' '.NFW::i()->cfg['project_version'];
	NFW::i()->assign('page', $CPages->record);
	NFW::i()->display('main.tpl');
}

// MAKE DEMO!
$DemoMaker = new ZXDemoMaker();

$parser_log = '';

// Load / validate / parse GIF
$errors = array();
$uploaded_gif = $DemoMaker->upload('gif_file1');
if (!$DemoMaker->error) {
	require_once PROJECT_ROOT.'include/helpers/parseGif256x192.php';
	$parser = new parseGif256x192(array('procPrefix' => 'anma1'));
	$gif1 = $parser->parseGIF($uploaded_gif);
	
	// Custom animation speed
	if ($_POST['speed1']) {
		$speed = intval($_POST['speed1']) < 1 || intval($_POST['speed1']) > 8 ? 1 : intval($_POST['speed1']);
		foreach ($gif1['frames'] as $key=>$foo) {
			$gif1['frames'][$key]['duration'] = $speed; 
		}
	}
	
	$parser_log .=  '<div class="'.($parser->totalstat > 40000 ? 'error' : '').'">Animation 1 size: <strong>'.$parser->totalstat.'</strong> bytes</div>';
}
else 
	$gif1 = false;

// Load / validate / parse GIF2
$errors = array();
$uploaded_gif = $DemoMaker->upload('gif_file2');
if (!$DemoMaker->error) {
	$parser = new parseGif256x192(array('procPrefix' => 'anma2'));
	$gif2 = $parser->parseGIF($uploaded_gif);

	// Custom animation speed
	if ($_POST['speed2']) {
		$speed = intval($_POST['speed2']) < 1 || intval($_POST['speed2']) > 8 ? 1 : intval($_POST['speed2']);
		foreach ($gif2['frames'] as $key=>$foo) {
			$gif2['frames'][$key]['duration'] = $speed;
		}
	}
	
	$parser_log .=  '<div class="'.($parser->totalstat > 16000 ? 'error' : '').'">Animation 2 size: <strong>'.$parser->totalstat.'</strong> bytes</div>';
}
else 
	$gif2 = false;

// Load / validate / parse GIF3
$errors = array();
$uploaded_gif = $DemoMaker->upload('gif_file3');
if (!$DemoMaker->error) {
	$parser = new parseGif256x192(array('procPrefix' => 'anma3'));
	$gif3 = $parser->parseGIF($uploaded_gif);

	// Custom animation speed
	if ($_POST['speed3']) {
		$speed = intval($_POST['speed3']) < 1 || intval($_POST['speed3']) > 8 ? 1 : intval($_POST['speed3']);
		foreach ($gif3['frames'] as $key=>$foo) {
			$gif3['frames'][$key]['duration'] = $speed;
		}
	}
	
	$parser_log .=  '<div class="'.($parser->totalstat > 16000 ? 'error' : '').'">Animation 3 size: <strong>'.$parser->totalstat.'</strong> bytes</div>';	
}
else
	$gif3 = false;

// Make sources params
$params = array(
	'border' => intval($_POST['border']) < 0 || intval($_POST['border']) > 7 ? 0 : intval($_POST['border']),
	'animation_border' => intval($_POST['animation_border']) < 0 || intval($_POST['animation_border']) > 7 ? 0 : intval($_POST['animation_border']),
	'splash_delay' => intval($_POST['splash_delay']) < 0 || intval($_POST['splash_delay']) > 5 ? 0 : intval($_POST['splash_delay']),
	
	'gif1' => $gif1,
	'gif2' => $gif2,
	'gif3' => $gif3,
);

$main_color = intval($_POST['gif_ink'] + $_POST['gif_paper'] * 8 + $_POST['gif_bright'] * 64);
$params['main_color'] = $main_color < 0 || $main_color > 255 ? 0x47 : $main_color; 



// PT3 / PT2 music
$music_file = $DemoMaker->upload('music_file');
if (!$DemoMaker->error) {
	$params['music_file'] = $music_file; 
}


// Splash screen
$splash_file = $DemoMaker->upload('splash_file');
if (!$DemoMaker->error) {
	$params['splash_file'] = $splash_file; 
	$params['splash_delay'] = intval($_POST['splash_delay']) < 1 || intval($_POST['splash_delay']) > 5 ? 1 : intval($_POST['splash_delay']);
}


// Main background
$gif_background = $DemoMaker->upload('gif_background');
if (!$DemoMaker->error) {
	$params['gif_background'] = $gif_background;
}


// Scroll
if ($_POST['scroll_text']) {
	$params['scroll_text'] = $_POST['scroll_text'];
	$params['scroll_font'] = intval($_POST['scroll_font']) < 1 || intval($_POST['scroll_font']) > 3 ? '16x16font1' : '16x16font'.intval($_POST['scroll_font']);
	list($params['scroll_address'], $params['scroll_attr']) = explode('|', $_POST['scroll_position']);
	
	$scroll_color = intval($_POST['scroll_ink'] + $_POST['scroll_paper'] * 8 + $_POST['scroll_bright'] * 64);
	$params['scroll_color'] = $scroll_color < 0 || $scroll_color > 255 ? 0x47 : $scroll_color;
}

// Analyzator
$ach = isset($_POST['analyzator_chanel']) ? intval($_POST['analyzator_chanel']) : 0; 
if ($ach >= 8 && $ach <= 11) {
	$params['analyzator_chanel'] = $ach;
	$params['analyzator_sens'] = intval($_POST['analyzator_sens']) < 8 || intval($_POST['analyzator_sens']) > 15 ? 15 : intval($_POST['analyzator_sens']);
}

// Analyzator in splash
$ach = isset($_POST['analyzator_splash_chanel']) ? intval($_POST['analyzator_splash_chanel']) : 0;
if ($ach >= 8 && $ach <= 11) {
	$params['analyzator_splash_chanel'] = $ach;
	$params['analyzator_splash_sens'] = intval($_POST['analyzator_splash_sens']) < 8 || intval($_POST['analyzator_splash_sens']) > 15 ? 15 : intval($_POST['analyzator_splash_sens']);
}

$DemoMaker->generateDemo($params);

exec('/out/make.cmd');

//ob_start();
//passthru('/out/make.cmd');
//$compiler_log = ob_get_clean();

// Response
NFW::i()->renderJSON(array('result' => 'success', 'log' => 'Done!<br /><br />'.$parser_log));

